<!DOCTYPE html>
<html>
  <head>
    <title>Scorebord</title>
    <link href="https://fonts.cdnfonts.com/css/futura-condensed-pt" rel="stylesheet">
    <link rel="apple-touch-icon" sizes="180x180" href="apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="favicon-16x16.png">
    <link rel="manifest" href="site.webmanifest">


    <style>
      html, body {
        height: 100%;
        width: 100%;
        margin: 0;
        padding: 0;
      }

      body {
        color: <%= colors.watervlo_yellow %>;
        font-family: 'Futura Condensed PT', sans-serif;
        overflow: hidden;
        overflow-x: hidden;
        background-image: Url('media/background.svg');
        background-size: cover;
      }

      #header {
        box-sizing: border-box;
        height: 25%;
        padding-left: 5px;
        padding-right: 5px;
      }

      #header-team {
        height: 100%;
        width: 60%;
        float: left;
        text-align: left;
        color: #F8D328;
      }

      #header-time {
        color: black;
        height: 130%;
        width: 30%;
        float: right;
        font-weight: 900;
        text-align: left;
        line-height: 0;
        margin-right: 5%;
      }

      .page {
        visibility: hidden;
        position: absolute;
        height: 75%;
        width: 100%;
        margin: 0;
        padding: 0;
      }

      .subpage {
        visibility: hidden;
        position: absolute;
        height: 100%;
        width: 100%;
        margin: 0;
        padding: 0;
      }

      .max-size {
        position: absolute;
        height: 100%;
        width: 100%;
      }

      #visual-buzzer {
        display: none;
        position: fixed;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background: red;
      }

    </style>

    <% files.forEach((file) => { %>
    <%- `<!-- ${file.split('.')[0]} page css -->` %>
    <%- include('scoreboard_pages/' + file, { section: 'css' }) %>
    <% }); %>

    <!-- Include scripts -->
    <script type="text/javascript" src="textFit.min.js"></script>
    <script type="text/javascript" src="simplepeer.min.js"></script>
    <script>
      <%- include('numberPad.js') %>
    </script>
    <script>
      <%- include('timer.js') %>
    </script>

    <!-- Websocket scripts -->
    <script>
      <%- include('websocket.js', { clientType: 'scoreboard' }) %>
    
      let peer

      function createPeer() {
          peer = new SimplePeer({
            initiator: false,
            trickle: false
          })

          peer.on('error', err => console.log('Peer error:', err))

          peer.on('signal', data => {
              connection.sendCommand('global', 'webrtc', { data: data, target: 'controlpanel'})
          })

          peer.on('connect', () => {
            console.log('Connected to peer')
          })

          peer.on('close', () => {
            console.log('Closed connection to peer')
            createPeer()
          })

          peer.on('stream', stream => {
            var audio = document.querySelector('#local-audio')
            audio.srcObject = stream
            audio.play()
          })
      }
      createPeer()

      registerCommand('global', 'webrtc', (data) => {
        if (data.target === 'scoreboard' && peer) {
          peer.signal(data.data)
        }
      })

      registerCommand('global', 'data', (data) => {
        changePage(data.page)

        document.getElementById('active-team').innerHTML = data.activeTeam
        fitText(document.getElementById('header-team'))
        
        document.body.style.backgroundImage = data.page === 'start' ? 'Url(media/background.svg)' : 'Url(media/background2.svg)'
      })
    </script>

    <!-- TextFit scripts -->
    <script>
      function fitText(element) {
        textFit(element, { alignVert: true, maxFontSize: 500, multiline: true })
      }
      function fitAllText() {
        fitText(document.getElementsByClassName('text-fit'))
      }
    </script>

  </head>
  <body onload="fitAllText()" onresize="fitAllText()">
    <div id="header">
      <div id="header-team" class="text-fit">
        <div><b>ZPC WATERVLO</b></div>
        <div id="active-team"></div>
      </div>
      <div id="header-time" class="text-fit">
        00:00:00
      </div>
    </div>

    <% files.forEach((file) => { %>
    <%- `<!-- ${file.split('.')[0]} page html -->` %>
    <%- include('scoreboard_pages/' + file, { section: 'html' }) %>
    <% }); %>

    <audio id="local-audio" autoplay />

    <!-- Buzzer/sounds scripts -->
    <audio id="buzzer">
      <source src="media/buzzer.wav" type="audio/wav">
    </audio>
    <audio id="buzzer-end-period">
      <source src="media/endPeriod.wav" type="audio/wav">
    </audio>
    <audio id="buzzer-end-shotclock">
      <source src="media/endShotclock.wav" type="audio/wav">
    </audio>
    <div id="visual-buzzer"></div>

    <script>
      const buzzer = document.getElementById("buzzer")
      const buzzerEndPeriod = document.getElementById("buzzer-end-period")
      const buzzerEndShotclock = document.getElementById("buzzer-end-shotclock")
      const visualBuzzer = document.getElementById("visual-buzzer")
      buzzer.muted = false
      buzzerEndPeriod.muted = false
      buzzerEndShotclock.muted = false
      let loops = 1

      function playBuzzer(loop = 1, visual = true) {
        loops = loop
        buzzer.play()
        if (visual) {
          showVisualBuzzer()
        }
      }

      function playEndPeriod(visual = true) {
        buzzerEndPeriod.play()
        if (visual) {
          showVisualBuzzer()
        }
      }

      function playEndShotclock(visual = true) {
        buzzerEndShotclock.play()
        if (visual) {
          showVisualBuzzer()
        }
      }

      function showVisualBuzzer() {
        visualBuzzer.style.display = 'block'
        setTimeout(() => {
          visualBuzzer.style.display = 'none'
        }, 1000)
      }

      buzzer.onended = () => {
        loops--
        if (loops > 0) {
          buzzer.play()
        }
      }

    </script> 

    <!-- Header scripts -->
    <script>
      const timeElement = document.getElementById('header-time')

      function updateTime() {
        const d = new Date()
        let result = ""
        d.setTime(d.getTime()+timeOffset)
        result += (d.getHours()<10?"0":"") + d.getHours() + ":";
        result += (d.getMinutes()<10?"0":"") + d.getMinutes() + ":";
        result += (d.getSeconds()<10?"0":"") + d.getSeconds();
        
        timeElement.innerHTML = result;
        fitText(timeElement)
      }

      setInterval(updateTime, 200)
      updateTime()
    </script>

    <% files.forEach((file) => { %>
    <%- `<!-- ${file.split('.')[0]} page javascript -->` %>
    <%- include('scoreboard_pages/' + file, { section: 'js' }) %>
    <% }); %>
  </body>
</html>
